#Esercitazione LSPP

#attivare i pacchetti evd, MASS, zoo

list.files()#vedo i files all'interno
read.table("Precipitazioni orarie.txt")  #genero la matrice dei dati pluviometrici

#realizzazione del boxplot

read.table("Precipitazioni orarie.txt", header=TRUE) ->data1
data1[,4]                                                       #test per vedere se  il file giusto
length(data1[,4])
rep(c(1,3,6,12,24),each=54)->h
h
c(data1[[2]],data1[[3]],data1[[4]],data1[[5]],data1[[6]])->hh   #data[[n]] sono gli elementi della N-esima colonna
hh                                                              #ho generato un vettore (riga) di n colonne (una matrice)
plot(hh ~ h, xlab="Durata [ore]",ylab="Precipitazione [mm]",main="Precipitazioni massime a Mezzolombardo")
boxplot(hh ~ h, xlab="Durata [ore]",ylab="Precipitazione [mm]",main="Precipitazioni massime a Mezzolombardo durate maggiori")

#istogrammi relativi alle varie ore

par(mfrow=c(1,5))
hist(data1[[2]], breaks=10,xlab="Precipitazioni in mm",ylab="Frequenza",main="durata 1 ora",col="blue") #istogramma delle piogge di durata 1 ora
hist(data1[[3]], breaks=10,xlab="Precipitazioni in mm",ylab="Frequenza",main="durata 3 ore",col="orange")
hist(data1[[4]], breaks=10,xlab="Precipitazioni in mm",ylab="Frequenza",main="durata 6 ore",col="yellow")
hist(data1[[5]], breaks=10,xlab="Precipitazioni in mm",ylab="Frequenza",main="durata 12 ore",col="green")
hist(data1[[6]], breaks=10,xlab="Precipitazioni in mm",ylab="Frequenza",main="durata 24 ore",col="dark green")
#Ora si procede al calcolo delle LSPP


#_____________________________________________________

#LSPP 1 ORA

par(mfrow=c(1,1))
hist(data1[[2]], breaks=10,xlab="Precipitazioni in mm",ylab="Frequenza",main="durata 1 ora",col="blue")
#ho riportato per avere solo quello di un ora incrementando gli intervalli da 8 a 10

data1[,2]->data1h #estraggo e definisco i valori relativi a 1 ora ovvero estraggo la 2a colonna dalla matrice dei dati
data1h            #controllo
hist(data1h,breaks=10,xlab="Precipitazioni in mm",ylab="frequenza",main="durata 1 ora",col="blue")  #stesso grafico di prima, fatto per  controllo

#1 ORA -metodo dei momenti-

#devo definire la funzione bc+a=media
#devo definire la funzione b^2pi^2/6=var

mean(data1h) ->m1h  #definisco la media
m1h
var(data1h) ->v1h   #definisco la varianza
v1h

#ora definisco le curve di Gumbel

(sqrt(v1h*6)/pi)->b1.1gumbel #definisco l'operazione per il calcolo del parametro b di Gumbel relativamente al caso di 1 ora
gamma<-0.57721566490
(m1h-b1.1gumbel*gamma)->a1.1gumbel #discorso analogo per a
b1.1gumbel
a1.1gumbel

#disegno della curva di Gumbel

z.1<-sort(data1h) #devono essere ordinati
pgumbel(z.1,loc=a1.1gumbel,scale=b1.1gumbel) -> t.1
plot(z.1,t.1,xlab="h [mm]",ylab="P[H<h]",col="blue",type="l") #disegno del primo grafico
ecdf(data1h)->ecdf1
plot(ecdf1,xlab="h [mm]",main="Freq di non superamento",add=T) #aggiungo l'ecdf dei dati a quella di Gumbel

#Metodo dei minimi quadrati

#Logaritmico per non avere problemi con l'esponenziale

Fi1<- ecdf1(sort(data1h)) #restituisce la probabilit di non superamento dei dati orari
Fi1 #sono le probabilit di non superamento 50 valori infatti il piu basso  1/50 (0.02) il pi alto  il 100% (1)
Y1<- -(log(-log(Fi1))) #ho linearizzato l'equazione dei minimi quadrati
Y1                     #ha un -inf che devo eliminare
Y1<- -(log(-log(Fi1[-54]))) #elimino l'elemento che non mi interessa e ridefinisco la funzione
Y1
X1<-sort(data1h)[-54] #x e y devono avere la stessa lunghezza
X1
lsfit(X1,Y1) -> fts1 #ho interpolato linearmente
fts1$coefficients

#mi trovo i coefficienti di Gumbel relativi a questo metodo

b2.1gumbel<- fts1$coefficients[[2]]^-1
a2.1gumbel<- -fts1$coefficients[[1]]*b2.1gumbel
b2.1gumbel
a2.1gumbel

zmq1<- sort(data1h)
pgumbel(zmq1,loc=a2.1gumbel,scale=b2.1gumbel) -> tmq1
plot(zmq1,tmq1,xlab="h [mm]",ylab="P[H<h]",col="red",type="l")
ecdf(data1h)->ecdf1
plot(ecdf1,xlab="h [mm]",main="Freq di non superamento",add=T) #procedura come altro metodo

#Metodo della massima verosimiglianza

#attivare il pacchetto MASS

fitdistr(data1h,densfun=dgumbel,start=list(loc=a1.1gumbel,scale=b1.1gumbel))->mlab1 # gi tutto implementato nel pacchetto
mlab1
a3.1gumbel = 16.2541741
b3.1gumbel = 6.3020071

zmv1<- sort(data1h)
pgumbel(zmv1,loc=a3.1gumbel,scale=b3.1gumbel) -> tmv1
plot(zmv1,tmv1,xlab="h [mm]",ylab="P[H<h]",col="green",type="l")
ecdf(data1h)->ecdf1
plot(ecdf1,xlab="h [mm]",main="Freq di non superamento",add=T) #procedura come altro metodo
lines(z.1,t.1,xlab="h [mm]",ylab="P[H<h]",col="red",type="l")
lines(zmq1,tmq1,xlab="h [mm]",ylab="P[H<h]",col="blue",type="l")
text(40,0.3,"___",cex=0.8,col="red")
text(45,0.3,"Momenti",cex=0.8,col="black")
text(40,0.25,"___",cex=0.8,col="blue")
text(46.75,0.25,"Minimi quadrati",cex=0.8,col="black")
text(40,0.2,"___",cex=0.8,col="green")
text(45,0.2,"M. veros.",cex=0.8,col="black")


#ora ho 3 coppie di parametri-> Test di Pearson per vedere quali sono i parametri piu corretti

#definisco il vettore coi parametri

v.1 = c(a1.1gumbel,b1.1gumbel,a2.1gumbel,b2.1gumbel,a3.1gumbel,b3.1gumbel)
v.1

#devo suddividere il campo in N parti, derivarne una suddivisione del dominio
#contare il numero di dati in ciascun campo
q=c(0.2,0.4,0.6,0.8) #divido in 5 campi da 0 a 20%... da 80 a 100%
qgumbel(q,loc=a1.1gumbel,scale=b1.1gumbel)->qi.1.1 #mi da il valore sull'asse x corrispondente alla probabilit assegnata
qi.1.1

#conto quanti elementi ci stanno dentro sono vettori perci li faccio tutti in un colpo solo invece che ripetere il procedimento per ogni scalare
c(0,ecdf1(qi.1.1)*54) ->no1.1.1 #quanti elementi stanno in ogni intervallo ecdf<1 -> moltiplico per il num di elementi
c(ecdf1(qi.1.1)*54,54)->no2.1.1 #quanti el stanno in un intervallo successivo
no2.1.1-no1.1.1->no.1.1 #numero degli elementi in un intervallo
no.1.1
#abbiamo suddiviso in 5 intervalli perci ogni intervallo avr un 20% (n=0.20) di probabilit
#vedi formula del test di Pearson cio calcolo del chiquadro:

0.2*length(data1h)->deltapi.1.1
X.1.1=sum((no.1.1-deltapi.1.1)^2/deltapi.1.1)
X.1.1

#ho trovato il chiquadro relativo al metodo dei momenti

#ripeto il procedimento per gli altri due metodi, chi restitur il valore minore sar il piu corretto

#Test metodo dei minimi quadrati

qgumbel(q,loc=a2.1gumbel,scale=b2.1gumbel)->qi.1.2
qi.1.2


c(0,ecdf1(qi.1.2)*54) ->no1.1.2 #variano rispetto a prima perch sono cambiati i parametri a, b
c(ecdf1(qi.1.2)*54,54)->no2.1.2
no2.1.2-no1.1.2->no.1.2 
no.1.2


0.2*length(data1h)->deltapi.1.2
X.1.2=sum((no.1.2-deltapi.1.2)^2/deltapi.1.2)
X.1.2

#Test metodo massima verosimiglianza

qgumbel(q,loc=a3.1gumbel,scale=b3.1gumbel)->qi.1.3
qi.1.3


c(0,ecdf1(qi.1.3)*54) ->no1.1.3 #variano rispetto a prima perch sono cambiati i parametri a, b
c(ecdf1(qi.1.3)*54,54)->no2.1.3 
no2.1.3-no1.1.3->no.1.3 
no.1.3


0.2*length(data1h)->deltapi.1.3
X.1.3=sum((no.1.3-deltapi.1.3)^2/deltapi.1.3)
X.1.3

xfin.1<-(c(X.1.1,X.1.2,X.1.3))
xfin.1
sort(xfin.1)   #mi trovo il minimo

#il minimo  relativo al metodo 3

#plot della curva relativa ad 1 ora
seq(from=1,to=150,by=0.1)->x #genero dei valori per l'asse x da 0 a 150 con incrementi di 0.1
Fp.1<- pgumbel(x,loc=a3.1gumbel,scale=b3.1gumbel) #funzione coi parametri del miglior metodo
plot(x,Fp.1,type="l",col="blue")

#pgumbel mi da la CUMULATA
#dgumbel mi da la DISTRIBUZIONE

Fd.1<- dgumbel(x,loc=a3.1gumbel,scale=b3.1gumbel) #funzione coi parametri del miglior metodo
plot(x,Fd.1,type="l",col="blue",xlab="Precipitazione [mm]",ylab="P[h]")
text(25,0.02,"1h",cex=0.8,col="blue")

#________________________________________________________________________________

# 3 ORE

hist(data1[[3]], breaks=10,xlab="Precipitazioni in mm",ylab="Frequenza",main="durata 1 ora",col="blue")
#ho riportato per avere solo quello di un ora incrementando gli intervalli da 8 a 10

data1[,3]->data3h #estraggo e definisco i valori relativi a 1 ora ovvero estraggo la 2a colonna dalla matrice dei dati
data3h            #controllo
hist(data3h,breaks=10,xlab="Precipitazioni in mm",ylab="frequenza",main="durata 1 ora",col="blue")  #stesso grafico di prima, fatto per  controllo

#3 ORA -metodo dei momenti-

#devo definire la funzione bc+a=media
#devo definire la funzione b^2pi^2/6=var

mean(data3h) ->m3h  #definisco la media
m3h
var(data3h) ->v3h   #definisco la varianza
v3h

#ora definisco le curve di Gumbel

(sqrt(v3h*6)/pi)->b1.3gumbel #definisco l'operazione per il calcolo del parametro b di Gumbel relativamente al caso di 1 ora
(m3h-b1.3gumbel*gamma)->a1.3gumbel #discorso analogo per a
b1.3gumbel
a1.3gumbel

#disegno della curva di Gumbel

z.3<-sort(data3h) #devono essere ordinati
pgumbel(z.3,loc=a1.3gumbel,scale=b1.3gumbel) -> t.3
plot(z.3,t.3,xlab="h [mm]",ylab="P[H<h]",col="blue",type="l") #disegno del primo grafico
ecdf(data3h)->ecdf3
plot(ecdf3,xlab="h [mm]",main="Freq di non superamento",add=T) #aggiungo l'ecdf dei dati a quella di Gumbel

#Metodo dei minimi quadrati

#Logaritmico per non avere problemi con l'esponenziale

Fi3<- ecdf3(sort(data3h)) #restituisce la probabilit di non superamento dei dati orari
Fi3 #sono le probabilit di non superamento 50 valori infatti il piu basso  1/50 (0.02) il pi alto  il 100% (1)
Y3<- -(log(-log(Fi3))) #ho linearizzato l'equazione dei minimi quadrati
Y3                     #ha un -inf che devo eliminare
Y3<- -(log(-log(Fi3[-54]))) #elimino l'elemento che non mi interessa e ridefinisco la funzione
Y3
X3<-sort(data3h)[-54] #x e y devono avere la stessa lunghezza
X3
lsfit(X3,Y3) -> fts3 #ho interpolato linearmente
fts3$coefficients

#mi trovo i coefficienti di Gumbel relativi a questo metodo

b2.3gumbel<- fts3$coefficients[[2]]^-1
a2.3gumbel<- -fts3$coefficients[[1]]*b2.3gumbel
b2.3gumbel
a2.3gumbel

zmq3<- sort(data3h)
pgumbel(zmq3,loc=a2.3gumbel,scale=b2.3gumbel) -> tmq3
plot(zmq3,tmq3,xlab="h [mm]",ylab="P[H<h]",col="red",type="l")
ecdf(data3h)->ecdf3
plot(ecdf3,xlab="h [mm]",main="Freq di non superamento",add=T) #procedura come altro metodo

#Metodo della massima verosimiglianza

#attivare il pacchetto MASS

fitdistr(data3h,densfun=dgumbel,start=list(loc=a1.3gumbel,scale=b1.3gumbel))->mlab3 # gi tutto implementato nel pacchetto
mlab3
a3.3gumbel = 23.4125452
b3.3gumbel = 8.3302764

zmv3<- sort(data3h)
pgumbel(zmv3,loc=a3.3gumbel,scale=b3.3gumbel) -> tmv3
plot(zmv3,tmv3,xlab="h [mm]",ylab="P[H<h]",col="green",type="l")
ecdf(data3h)->ecdf3
plot(ecdf3,xlab="h [mm]",main="Freq di non superamento",add=T) #procedura come altro metodo
lines(z.3,t.3,xlab="h [mm]",ylab="P[H<h]",col="red",type="l")
lines(zmq3,tmq3,xlab="h [mm]",ylab="P[H<h]",col="blue",type="l")
text(60,0.3,"___",cex=0.8,col="red")
text(66,0.3,"Momenti",cex=0.8,col="black")
text(60,0.25,"___",cex=0.8,col="blue")
text(68.5,0.25,"Minimi quadrati",cex=0.8,col="black")
text(60,0.2,"___",cex=0.8,col="green")
text(66,0.2,"M. veros.",cex=0.8,col="black")

#ora ho 3 coppie di parametri-> Test di Pearson per vedere quali sono i parametri piu corretti

#definisco il vettore coi parametri

v.3 = c(a1.3gumbel,b1.3gumbel,a2.3gumbel,b2.3gumbel,a3.3gumbel,b3.3gumbel)
v.3

#devo suddividere il campo in N parti, derivarne una suddivisione del dominio
#contare il numero di dati in ciascun campo
q=c(0.2,0.4,0.6,0.8) #divido in 5 campi da 0 a 20%... da 80 a 100%
qgumbel(q,loc=a1.3gumbel,scale=b1.3gumbel)->qi.3.1 #mi da il valore sull'asse x corrispondente alla probabilit assegnata
qi.3.1

#conto quanti elementi ci stanno dentro sono vettori perci li faccio tutti in un colpo solo invece che ripetere il procedimento per ogni scalare
c(0,ecdf3(qi.3.1)*54) ->no1.3.1 #quanti elementi stanno in ogni intervallo ecdf<1 -> moltiplico per il num di elementi
c(ecdf3(qi.3.1)*54,54)->no2.3.1 #quanti el stanno in un intervallo successivo
no2.3.1-no1.3.1->no.3.1 #numero degli elementi in un intervallo
no.3.1

#abbiamo suddiviso in 5 intervalli perci ogni intervallo avr un 20% (n=0.20) di probabilit
#vedi formula del test di Pearson cio calcolo del chiquadro:

0.2*length(data3h)->deltapi.3.1
X.3.1=sum((no.3.1-deltapi.3.1)^2/deltapi.3.1)
X.3.1

#ho trovato il chiquadro relativo al metodo dei momenti

#ripeto il procedimento per gli altri due metodi, chi restitur il valore minore sar il piu corretto

#Test metodo dei minimi quadrati

qgumbel(q,loc=a2.3gumbel,scale=b2.3gumbel)->qi.3.2
qi.3.2


c(0,ecdf3(qi.3.2)*54) ->no1.3.2 #variano rispetto a prima perch sono cambiati i parametri a, b
c(ecdf3(qi.3.2)*54,54)->no2.3.2
no2.3.2-no1.3.2->no.3.2 
no.3.2


0.2*length(data3h)->deltapi.3.2
X.3.2=sum((no.3.2-deltapi.3.2)^2/deltapi.3.2)
X.3.2

#Test metodo massima verosimiglianza

qgumbel(q,loc=a3.3gumbel,scale=b3.3gumbel)->qi.3.3
qi.3.3


c(0,ecdf3(qi.3.3)*54) ->no1.3.3 #variano rispetto a prima perch sono cambiati i parametri a, b
c(ecdf3(qi.3.3)*54,54)->no2.3.3 
no2.3.3-no1.3.3->no.3.3 
no.3.3


0.2*length(data3h)->deltapi.3.3
X.3.3=sum((no.3.3-deltapi.3.3)^2/deltapi.3.3)
X.3.3

xfin.3<-(c(X.3.1,X.3.2,X.3.3))
xfin.3
sort(xfin.3)   #mi trovo il minimo

#il minimo  relativo al metodo 2

#plot della curva relativa ad 3 ore
seq(from=1,to=150,by=0.1)->x #genero dei valori per l'asse x da 0 a 150 con incrementi di 0.1
Fp.3<- pgumbel(x,loc=a2.3gumbel,scale=b2.3gumbel) #funzione coi parametri del miglior metodo
plot(x,Fp.3,type="l",col="orange")

#pgumbel mi da la CUMULATA
#dgumbel mi da la DISTRIBUZIONE

Fd.3<- dgumbel(x,loc=a2.3gumbel,scale=b2.3gumbel) #funzione coi parametri del miglior metodo
plot(x,Fd.3,type="l",col="orange",xlab="Precipitazione [mm]",ylab="P[h]")
text(50,0.02,"3h",cex=0.8,col="orange")

#__________________________________________________________________________________

# 6 ORE

hist(data1[[4]], breaks=10,xlab="Precipitazioni in mm",ylab="Frequenza",main="durata 6 ore",col="yellow")
#ho riportato per avere solo quello di un ora incrementando gli intervalli da 8 a 10
data1[,4]->data6h #estraggo e definisco i valori relativi a 1 ora ovvero estraggo la 2a colonna dalla matrice dei dati
data6h            #controllo
hist(data6h,breaks=10,xlab="Precipitazioni in mm",ylab="frequenza",main="durata 6 ore",col="yellow")  #stesso grafico di prima, fatto per  controllo

#6 ORE -metodo dei momenti-

#devo definire la funzione bc+a=media
#devo definire la funzione b^2pi^2/6=var

mean(data6h) ->m6h  #definisco la media
m6h
var(data6h) ->v6h   #definisco la varianza
v6h

#ora definisco le curve di Gumbel

(sqrt(v6h*6)/pi)->b1.6gumbel #definisco l'operazione per il calcolo del parametro b di Gumbel relativamente al caso di 1 ora
(m6h-b1.6gumbel*gamma)->a1.6gumbel #discorso analogo per a
b1.6gumbel
a1.6gumbel

#disegno della curva di Gumbel

z.6<-sort(data6h) #devono essere ordinati
pgumbel(z.6,loc=a1.6gumbel,scale=b1.6gumbel) -> t.6
plot(z.6,t.6,xlab="h [mm]",ylab="P[H<h]",col="blue",type="l") #disegno del primo grafico
ecdf(data6h)->ecdf6
plot(ecdf6,xlab="h [mm]",main="Freq di non superamento",add=T) #aggiungo l'ecdf dei dati a quella di Gumbel

#Metodo dei minimi quadrati

#Logaritmico per non avere problemi con l'esponenziale

Fi6<- ecdf6(sort(data6h)) #restituisce la probabilit di non superamento dei dati orari
Fi6 #sono le probabilit di non superamento 50 valori infatti il piu basso  1/50 (0.02) il pi alto  il 100% (1)
Y6<- -(log(-log(Fi6))) #ho linearizzato l'equazione dei minimi quadrati
Y6                     #ha un -inf che devo eliminare
Y6<- -(log(-log(Fi6[-54]))) #elimino l'elemento che non mi interessa e ridefinisco la funzione
Y6
X6<-sort(data6h)[-54] #x e y devono avere la stessa lunghezza
X6
lsfit(X6,Y6) -> fts6 #ho interpolato linearmente
fts6$coefficients

#mi trovo i coefficienti di Gumbel relativi a questo metodo

b2.6gumbel<- fts6$coefficients[[2]]^-1
a2.6gumbel<- -fts6$coefficients[[1]]*b2.6gumbel
b2.6gumbel
a2.6gumbel

zmq6<- sort(data6h)
pgumbel(zmq6,loc=a2.6gumbel,scale=b2.6gumbel) -> tmq6
plot(zmq6,tmq6,xlab="h [mm]",ylab="P[H<h]",col="red",type="l")
ecdf(data6h)->ecdf6
plot(ecdf6,xlab="h [mm]",main="Freq di non superamento",add=T) #procedura come altro metodo

#Metodo della massima verosimiglianza

#attivare il pacchetto MASS

fitdistr(data6h,densfun=dgumbel,start=list(loc=a1.6gumbel,scale=b1.6gumbel))->mlab6 # gi tutto implementato nel pacchetto
mlab6
a3.6gumbel = 31.7364956
b3.6gumbel = 8.7097110

zmv6<- sort(data6h)
pgumbel(zmv6,loc=a3.6gumbel,scale=b3.6gumbel) -> tmv6
plot(zmv6,tmv6,xlab="h [mm]",ylab="P[H<h]",col="green",type="l")
ecdf(data6h)->ecdf6
plot(ecdf6,xlab="h [mm]",main="Freq di non superamento",add=T) #procedura come altro metodo
lines(z.6,t.6,xlab="h [mm]",ylab="P[H<h]",col="red",type="l")
lines(zmq6,tmq6,xlab="h [mm]",ylab="P[H<h]",col="blue",type="l")
text(68,0.3,"___",cex=0.8,col="red")
text(74,0.3,"Momenti",cex=0.8,col="black")
text(68,0.25,"___",cex=0.8,col="blue")
text(76.5,0.25,"Minimi quadrati",cex=0.8,col="black")
text(68,0.2,"___",cex=0.8,col="green")
text(74,0.2,"M. veros.",cex=0.8,col="black")



#ora ho 3 coppie di parametri-> Test di Pearson per vedere quali sono i parametri piu corretti

#definisco il vettore coi parametri

v.6 = c(a1.6gumbel,b1.6gumbel,a2.6gumbel,b2.6gumbel,a3.6gumbel,b3.6gumbel)
v.6

#devo suddividere il campo in N parti, derivarne una suddivisione del dominio
#contare il numero di dati in ciascun campo
q=c(0.2,0.4,0.6,0.8) #divido in 5 campi da 0 a 20%... da 80 a 100%
qgumbel(q,loc=a1.6gumbel,scale=b1.6gumbel)->qi.6.1 #mi da il valore sull'asse x corrispondente alla probabilit assegnata
qi.6.1

#conto quanti elementi ci stanno dentro sono vettori perci li faccio tutti in un colpo solo invece che ripetere il procedimento per ogni scalare
c(0,ecdf6(qi.6.1)*54) ->no1.6.1 #quanti elementi stanno in ogni intervallo ecdf<1 -> moltiplico per il num di elementi
c(ecdf6(qi.6.1)*54,54)->no2.6.1 #quanti el stanno in un intervallo successivo
no2.6.1-no1.6.1->no.6.1 #numero degli elementi in un intervallo
no.6.1

#abbiamo suddiviso in 5 intervalli perci ogni intervallo avr un 20% (n=0.20) di probabilit
#vedi formula del test di Pearson cio calcolo del chiquadro:

0.2*length(data6h)->deltapi.6.1
X.6.1=sum((no.6.1-deltapi.6.1)^2/deltapi.6.1)
X.6.1

#ho trovato il chiquadro relativo al metodo dei momenti

#ripeto il procedimento per gli altri due metodi, chi restitur il valore minore sar il piu corretto

#Test metodo dei minimi quadrati

qgumbel(q,loc=a2.6gumbel,scale=b2.6gumbel)->qi.6.2
qi.6.2


c(0,ecdf6(qi.6.2)*54) ->no1.6.2 #variano rispetto a prima perch sono cambiati i parametri a, b
c(ecdf6(qi.6.2)*54,54)->no2.6.2
no2.6.2-no1.6.2->no.6.2 
no.6.2


0.2*length(data6h)->deltapi.6.2
X.6.2=sum((no.6.2-deltapi.6.2)^2/deltapi.6.2)
X.6.2

#Test metodo massima verosimiglianza

qgumbel(q,loc=a3.6gumbel,scale=b3.6gumbel)->qi.6.3
qi.6.3


c(0,ecdf6(qi.6.3)*54) ->no1.6.3 #variano rispetto a prima perch sono cambiati i parametri a, b
c(ecdf6(qi.6.3)*54,54)->no2.6.3 
no2.6.3-no1.6.3->no.6.3 
no.6.3


0.2*length(data6h)->deltapi.6.3
X.6.3=sum((no.6.3-deltapi.6.3)^2/deltapi.6.3)
X.6.3

xfin.6<-(c(X.6.1,X.6.2,X.6.3))
xfin.6
sort(xfin.6)   #mi trovo il minimo

#il minimo  relativo al metodo 3

#plot della curva relativa ad 6 ore
seq(from=1,to=150,by=0.1)->x #genero dei valori per l'asse x da 0 a 150 con incrementi di 0.1
Fp.6<- pgumbel(x,loc=a3.6gumbel,scale=b3.6gumbel) #funzione coi parametri del miglior metodo
plot(x,Fp.6,type="l",col="yellow")

#pgumbel mi da la CUMULATA
#dgumbel mi da la DISTRIBUZIONE

Fd.6<- dgumbel(x,loc=a3.6gumbel,scale=b3.6gumbel) #funzione coi parametri del miglior metodo
plot(x,Fd.6,type="l",col="yellow",xlab="Precipitazione [mm]",ylab="P[h]")
text(50,0.02,"6h",cex=0.8,col="yellow")

#_________________________________________________________________________________

#12 ORE

hist(data1[[5]], breaks=10,xlab="Precipitazioni in mm",ylab="Frequenza",main="durata 12 ore",col="green")
#ho riportato per avere solo quello di un ora incrementando gli intervalli da 8 a 10
data1[,5]->data12h #estraggo e definisco i valori relativi a 1 ora ovvero estraggo la 2a colonna dalla matrice dei dati
data12h            #controllo
hist(data12h,breaks=10,xlab="Precipitazioni in mm",ylab="frequenza",main="durata 12 ore",col="green")  #stesso grafico di prima, fatto per  controllo

#6 ORE -metodo dei momenti-

#devo definire la funzione bc+a=media
#devo definire la funzione b^2pi^2/6=var

mean(data12h) ->m12h  #definisco la media
m12h
var(data12h) ->v12h   #definisco la varianza
v12h

#ora definisco le curve di Gumbel

(sqrt(v12h*6)/pi)->b1.12gumbel #definisco l'operazione per il calcolo del parametro b di Gumbel relativamente al caso di 1 ora
(m12h-b1.12gumbel*gamma)->a1.12gumbel #discorso analogo per a
b1.12gumbel
a1.12gumbel

#disegno della curva di Gumbel

z.12<-sort(data12h) #devono essere ordinati
pgumbel(z.12,loc=a1.12gumbel,scale=b1.12gumbel) -> t.12
plot(z.12,t.12,xlab="h [mm]",ylab="P[H<h]",col="blue",type="l") #disegno del primo grafico
ecdf(data12h)->ecdf12
plot(ecdf12,xlab="h [mm]",main="Freq di non superamento",add=T) #aggiungo l'ecdf dei dati a quella di Gumbel

#Metodo dei minimi quadrati

#Logaritmico per non avere problemi con l'esponenziale

Fi12<- ecdf12(sort(data12h)) #restituisce la probabilit di non superamento dei dati orari
Fi12 #sono le probabilit di non superamento 50 valori infatti il piu basso  1/50 (0.02) il pi alto  il 100% (1)
Y12<- -(log(-log(Fi12))) #ho linearizzato l'equazione dei minimi quadrati
Y12                     #ha un -inf che devo eliminare
Y12<- -(log(-log(Fi12[-54]))) #elimino l'elemento che non mi interessa e ridefinisco la funzione
Y12
X12<-sort(data12h)[-54] #x e y devono avere la stessa lunghezza
X12
lsfit(X12,Y12) -> fts12 #ho interpolato linearmente
fts12$coefficients

#mi trovo i coefficienti di Gumbel relativi a questo metodo

b2.12gumbel<- fts12$coefficients[[2]]^-1
a2.12gumbel<- -fts12$coefficients[[1]]*b2.12gumbel
b2.12gumbel
a2.12gumbel

zmq12<- sort(data12h)
pgumbel(zmq12,loc=a2.12gumbel,scale=b2.12gumbel) -> tmq12
plot(zmq12,tmq12,xlab="h [mm]",ylab="P[H<h]",col="red",type="l")
ecdf(data12h)->ecdf12
plot(ecdf12,xlab="h [mm]",main="Freq di non superamento",add=T) #procedura come altro metodo

#Metodo della massima verosimiglianza

#attivare il pacchetto MASS

fitdistr(data12h,densfun=dgumbel,start=list(loc=a1.12gumbel,scale=b1.12gumbel))->mlab12 # gi tutto implementato nel pacchetto
mlab12
a3.12gumbel = 43.121785
b3.12gumbel = 11.069070

zmv12<- sort(data12h)
pgumbel(zmv12,loc=a3.12gumbel,scale=b3.12gumbel) -> tmv12
plot(zmv12,tmv12,xlab="h [mm]",ylab="P[H<h]",col="green",type="l")
ecdf(data12h)->ecdf12
plot(ecdf12,xlab="h [mm]",main="Freq di non superamento",add=T) #procedura come altro metodo
lines(z.12,t.12,xlab="h [mm]",ylab="P[H<h]",col="red",type="l")
lines(zmq12,tmq12,xlab="h [mm]",ylab="P[H<h]",col="blue",type="l")
text(78,0.3,"___",cex=0.8,col="red")
text(84,0.3,"Momenti",cex=0.8,col="black")
text(78,0.25,"___",cex=0.8,col="blue")
text(86.5,0.25,"Minimi quadrati",cex=0.8,col="black")
text(78,0.2,"___",cex=0.8,col="green")
text(84,0.2,"M. veros.",cex=0.8,col="black")

#ora ho 3 coppie di parametri-> Test di Pearson per vedere quali sono i parametri piu corretti

#definisco il vettore coi parametri

v.12 = c(a1.12gumbel,b1.12gumbel,a2.12gumbel,b2.12gumbel,a3.12gumbel,b3.12gumbel)
v.12

#devo suddividere il campo in N parti, derivarne una suddivisione del dominio
#contare il numero di dati in ciascun campo
q=c(0.2,0.4,0.6,0.8) #divido in 5 campi da 0 a 20%... da 80 a 100%
qgumbel(q,loc=a1.12gumbel,scale=b1.12gumbel)->qi.12.1 #mi da il valore sull'asse x corrispondente alla probabilit assegnata
qi.12.1

#conto quanti elementi ci stanno dentro sono vettori perci li faccio tutti in un colpo solo invece che ripetere il procedimento per ogni scalare
c(0,ecdf12(qi.12.1)*54) ->no1.12.1 #quanti elementi stanno in ogni intervallo ecdf<1 -> moltiplico per il num di elementi
c(ecdf12(qi.12.1)*54,54)->no2.12.1 #quanti el stanno in un intervallo successivo
no2.12.1-no1.12.1->no.12.1 #numero degli elementi in un intervallo
no.12.1

#abbiamo suddiviso in 5 intervalli perci ogni intervallo avr un 20% (n=0.20) di probabilit
#vedi formula del test di Pearson cio calcolo del chiquadro:

0.2*length(data12h)->deltapi.12.1
X.12.1=sum((no.12.1-deltapi.12.1)^2/deltapi.12.1)
X.12.1

#ho trovato il chiquadro relativo al metodo dei momenti

#ripeto il procedimento per gli altri due metodi, chi restitur il valore minore sar il piu corretto

#Test metodo dei minimi quadrati

qgumbel(q,loc=a2.12gumbel,scale=b2.12gumbel)->qi.12.2
qi.12.2


c(0,ecdf12(qi.12.2)*54) ->no1.12.2 #variano rispetto a prima perch sono cambiati i parametri a, b
c(ecdf12(qi.12.2)*54,54)->no2.12.2
no2.12.2-no1.12.2->no.12.2 
no.12.2


0.2*length(data12h)->deltapi.12.2
X.12.2=sum((no.12.2-deltapi.12.2)^2/deltapi.12.2)
X.12.2

#Test metodo massima verosimiglianza

qgumbel(q,loc=a3.12gumbel,scale=b3.12gumbel)->qi.12.3
qi.12.3


c(0,ecdf12(qi.12.3)*54) ->no1.12.3 #variano rispetto a prima perch sono cambiati i parametri a, b
c(ecdf12(qi.12.3)*54,54)->no2.12.3 
no2.12.3-no1.12.3->no.12.3 
no.12.3


0.2*length(data12h)->deltapi.12.3
X.12.3=sum((no.12.3-deltapi.12.3)^2/deltapi.12.3)
X.12.3

xfin.12<-(c(X.12.1,X.12.2,X.12.3))
xfin.12
sort(xfin.12)   #mi trovo il minimo

#il minimo  relativo al metodo 1

#plot della curva relativa ad 12 ore
seq(from=1,to=150,by=0.1)->x #genero dei valori per l'asse x da 0 a 150 con incrementi di 0.1
Fp.12<- pgumbel(x,loc=a1.12gumbel,scale=b1.12gumbel) #funzione coi parametri del miglior metodo
plot(x,Fp.12,type="l",col="green")

#pgumbel mi da la CUMULATA
#dgumbel mi da la DISTRIBUZIONE

Fd.12<- dgumbel(x,loc=a1.12gumbel,scale=b1.12gumbel) #funzione coi parametri del miglior metodo
plot(x,Fd.12,type="l",col="green",xlab="Precipitazione [mm]",ylab="P[h]")
text(50,0.02,"12h",cex=0.8,col="green")

#________________________________________________________________________________

#24 ORE

hist(data1[[6]], breaks=10,xlab="Precipitazioni in mm",ylab="Frequenza",main="durata 24 ore",col="dark green")
#ho riportato per avere solo quello di un ora incrementando gli intervalli da 8 a 10
data1[,6]->data24h #estraggo e definisco i valori relativi a 1 ora ovvero estraggo la 2a colonna dalla matrice dei dati
data24h            #controllo
hist(data24h,breaks=10,xlab="Precipitazioni in mm",ylab="frequenza",main="durata 24 ore",col="dark green")  #stesso grafico di prima, fatto per  controllo

#24 ORE -metodo dei momenti-

#devo definire la funzione bc+a=media
#devo definire la funzione b^2pi^2/6=var

mean(data24h) ->m24h  #definisco la media
m24h
var(data24h) ->v24h   #definisco la varianza
v24h

#ora definisco le curve di Gumbel

(sqrt(v24h*6)/pi)->b1.24gumbel #definisco l'operazione per il calcolo del parametro b di Gumbel relativamente al caso di 1 ora
(m24h-b1.24gumbel*gamma)->a1.24gumbel #discorso analogo per a
b1.24gumbel
a1.24gumbel

#disegno della curva di Gumbel

z.24<-sort(data24h) #devono essere ordinati
pgumbel(z.24,loc=a1.24gumbel,scale=b1.24gumbel) -> t.24
plot(z.24,t.24,xlab="h [mm]",ylab="P[H<h]",col="blue",type="l") #disegno del primo grafico
ecdf(data24h)->ecdf24
plot(ecdf24,xlab="h [mm]",main="Freq di non superamento",add=T) #aggiungo l'ecdf dei dati a quella di Gumbel

#Metodo dei minimi quadrati

#Logaritmico per non avere problemi con l'esponenziale

Fi24<- ecdf24(sort(data24h)) #restituisce la probabilit di non superamento dei dati orari
Fi24 #sono le probabilit di non superamento 50 valori infatti il piu basso  1/50 (0.02) il pi alto  il 100% (1)
Y24<- -(log(-log(Fi24))) #ho linearizzato l'equazione dei minimi quadrati
Y24                     #ha un -inf che devo eliminare
Y24<- -(log(-log(Fi24[-54]))) #elimino l'elemento che non mi interessa e ridefinisco la funzione
Y24
X24<-sort(data24h)[-54] #x e y devono avere la stessa lunghezza
X24
lsfit(X24,Y24) -> fts24 #ho interpolato linearmente
fts24$coefficients

#mi trovo i coefficienti di Gumbel relativi a questo metodo

b2.24gumbel<- fts24$coefficients[[2]]^-1
a2.24gumbel<- -fts24$coefficients[[1]]*b2.24gumbel
b2.24gumbel
a2.24gumbel

zmq24<- sort(data24h)
pgumbel(zmq24,loc=a2.24gumbel,scale=b2.24gumbel) -> tmq24
plot(zmq24,tmq24,xlab="h [mm]",ylab="P[H<h]",col="red",type="l")
ecdf(data24h)->ecdf24
plot(ecdf24,xlab="h [mm]",main="Freq di non superamento",add=T) #procedura come altro metodo

#Metodo della massima verosimiglianza

#attivare il pacchetto MASS

fitdistr(data24h,densfun=dgumbel,start=list(loc=a1.24gumbel,scale=b1.24gumbel))->mlab24 # gi tutto implementato nel pacchetto
mlab24
a3.24gumbel = 59.141895
b3.24gumbel = 15.483705

zmv24<- sort(data24h)
pgumbel(zmv24,loc=a3.24gumbel,scale=b3.24gumbel) -> tmv24
plot(zmv24,tmv24,xlab="h [mm]",ylab="P[H<h]",col="green",type="l")
ecdf(data24h)->ecdf24
plot(ecdf24,xlab="h [mm]",main="Freq di non superamento",add=T) #procedura come altro metodo
lines(z.24,t.24,xlab="h [mm]",ylab="P[H<h]",col="red",type="l")
lines(zmq24,tmq24,xlab="h [mm]",ylab="P[H<h]",col="blue",type="l")
text(105,0.3,"___",cex=0.8,col="red")
text(114,0.3,"Momenti",cex=0.8,col="black")
text(105,0.25,"___",cex=0.8,col="blue")
text(118,0.25,"Minimi quadrati",cex=0.8,col="black")
text(105,0.2,"___",cex=0.8,col="green")
text(114.25,0.2,"M. veros.",cex=0.8,col="black")

#ora ho 3 coppie di parametri-> Test di Pearson per vedere quali sono i parametri piu corretti

#definisco il vettore coi parametri

v.24 = c(a1.24gumbel,b1.24gumbel,a2.24gumbel,b2.24gumbel,a3.24gumbel,b3.24gumbel)
v.24

#devo suddividere il campo in N parti, derivarne una suddivisione del dominio
#contare il numero di dati in ciascun campo
q=c(0.2,0.4,0.6,0.8) #divido in 5 campi da 0 a 20%... da 80 a 100%
qgumbel(q,loc=a1.24gumbel,scale=b1.24gumbel)->qi.24.1 #mi da il valore sull'asse x corrispondente alla probabilit assegnata
qi.24.1

#conto quanti elementi ci stanno dentro sono vettori perci li faccio tutti in un colpo solo invece che ripetere il procedimento per ogni scalare
c(0,ecdf24(qi.24.1)*54) ->no1.24.1 #quanti elementi stanno in ogni intervallo ecdf<1 -> moltiplico per il num di elementi
c(ecdf24(qi.24.1)*54,54)->no2.24.1 #quanti el stanno in un intervallo successivo
no2.24.1-no1.24.1->no.24.1 #numero degli elementi in un intervallo
no.24.1

#abbiamo suddiviso in 5 intervalli perci ogni intervallo avr un 20% (n=0.20) di probabilit
#vedi formula del test di Pearson cio calcolo del chiquadro:

0.2*length(data24h)->deltapi.24.1
X.24.1=sum((no.24.1-deltapi.24.1)^2/deltapi.24.1)
X.24.1

#ho trovato il chiquadro relativo al metodo dei momenti

#ripeto il procedimento per gli altri due metodi, chi restitur il valore minore sar il piu corretto

#Test metodo dei minimi quadrati

qgumbel(q,loc=a2.24gumbel,scale=b2.24gumbel)->qi.24.2
qi.24.2


c(0,ecdf24(qi.24.2)*54) ->no1.24.2 #variano rispetto a prima perch sono cambiati i parametri a, b
c(ecdf24(qi.24.2)*54,54)->no2.24.2
no2.24.2-no1.24.2->no.24.2 
no.24.2


0.2*length(data24h)->deltapi.24.2
X.24.2=sum((no.24.2-deltapi.24.2)^2/deltapi.24.2)
X.24.2

#Test metodo massima verosimiglianza

qgumbel(q,loc=a3.24gumbel,scale=b3.24gumbel)->qi.24.3
qi.24.3


c(0,ecdf24(qi.24.3)*54) ->no1.24.3 #variano rispetto a prima perch sono cambiati i parametri a, b
c(ecdf24(qi.24.3)*54,54)->no2.24.3 
no2.24.3-no1.24.3->no.24.3 
no.24.3


0.2*length(data24h)->deltapi.24.3
X.24.3=sum((no.24.3-deltapi.24.3)^2/deltapi.24.3)
X.24.3

xfin.24<-(c(X.24.1,X.24.2,X.24.3))
xfin.24
sort(xfin.24)   #mi trovo il minimo

#il minimo  relativo al metodo 3

#plot della curva relativa ad 24 ore
seq(from=1,to=150,by=0.1)->x #genero dei valori per l'asse x da 0 a 150 con incrementi di 0.1
Fp.24<- pgumbel(x,loc=a3.24gumbel,scale=b3.24gumbel) #funzione coi parametri del miglior metodo
plot(x,Fp.24,type="l",col="dark green")

#pgumbel mi da la CUMULATA
#dgumbel mi da la DISTRIBUZIONE

Fd.24<- dgumbel(x,loc=a3.24gumbel,scale=b3.24gumbel) #funzione coi parametri del miglior metodo
plot(x,Fd.24,type="l",col="dark green",xlab="Precipitazione [mm]",ylab="P[h]")
text(50,0.02,"24h",cex=0.8,col="dark green")



#_______________________________________________#

#pgumbel mi da la CUMULATA
#dgumbel mi da la DISTRIBUZIONE

Fd.24<- dgumbel(x,loc=a3.24gumbel,scale=b3.24gumbel) #funzione coi parametri del miglior metodo
plot(x,Fd.1,type="l",col="blue",xlab="Precipitazione [mm]",ylab="P[h]",main="Distribuzione")
lines(x,Fd.3,type="l",col="orange")
lines(x,Fd.6,type="l",col="yellow")
lines(x,Fd.12,type="l",col="green")
lines(x,Fd.24,type="l",col="dark green")
text(25,0.05,"1h",cex=0.8,col="blue")
text(28,0.045,"3h",cex=0.8,col="orange")
text(40,0.045,"6h",cex=0.8,col="yellow")
text(50,0.035,"12h",cex=0.8,col="green")
text(75,0.023,"24h",cex=0.8,col="dark green")

#pgumbel
length(x)

zzz<-rep(c(0.9), each=1491)
zzz
Fp.24<- pgumbel(x,loc=a3.24gumbel,scale=b3.24gumbel) #funzione coi parametri del miglior metodo
plot(x,Fp.1,type="l",col="blue",xlab="Precipitazione [mm]",ylab="P[h]",main="Cumulata")
lines(x,Fp.3,type="l",col="orange")
lines(x,Fp.6,type="l",col="yellow")
lines(x,Fp.12,type="l",col="green")
lines(x,Fp.24,type="l",col="dark green")
lines(x,zzz,type="l",cex=0.2,col="purple")
text(20,0.80,"1h",cex=0.8,col="blue")
text(28,0.70,"3h",cex=0.8,col="orange")
text(34,0.60,"6h",cex=0.8,col="yellow")
text(42,0.50,"12h",cex=0.8,col="green")
text(55,0.40,"24h",cex=0.8,col="dark green")


#Precipitazione per un assegnato tempo di ritorno

p<-function(tr){1-(1/tr)}  #probabilit in funzione del tempo di ritorno
t<- function(pr){1/(1-pr)} #tempo di ritorno per una assegnata probabilit con pr compreso tra 0 e 1 (100%)

#________________________________________________

#Tr di 5 anni
p(5) ->T5
T5

c(qgumbel(T5,loc=a3.1gumbel,scale=b3.1gumbel),qgumbel(T5,loc=a2.3gumbel,scale=b2.3gumbel),qgumbel(T5,loc=a3.6gumbel,scale=b3.6gumbel),qgumbel(T5,loc=a1.12gumbel,scale=b1.12gumbel),qgumbel(T5,loc=a3.24gumbel,scale=b3.24gumbel))->h5
d<-c(1,3,6,12,24)
lsfit(log(d),log(h5))->ft5
ft5$coefficients
hp<-seq(from=0,to=25,by=0.1)
exp(ft5$coefficients[[1]])
exp(ft5$coefficients[[1]])*hp^ft5$coefficients[[2]]->l5
plot(hp,l5,type="l",col="orange") #vedere se lasciare x o mettere d

#Tr di 10 anni
p(10) ->T10
T10

c(qgumbel(T10,loc=a3.1gumbel,scale=b3.1gumbel),qgumbel(T10,loc=a2.3gumbel,scale=b2.3gumbel),qgumbel(T10,loc=a3.6gumbel,scale=b3.6gumbel),qgumbel(T10,loc=a1.12gumbel,scale=b1.12gumbel),qgumbel(T10,loc=a3.24gumbel,scale=b3.24gumbel))->h10
d<-c(1,3,6,12,24)
lsfit(log(d),log(h10))->ft10
ft10$coefficients #x  l'esopnente n delle curve
exp(ft10$coefficients[[1]]) # il coefficiente a(Tr)
exp(ft10$coefficients[[1]])*hp^ft10$coefficients[[2]]->l10

#Tr di 20 anni
p(20) ->T20
T20

c(qgumbel(T20,loc=a3.1gumbel,scale=b3.1gumbel),qgumbel(T20,loc=a2.3gumbel,scale=b2.3gumbel),qgumbel(T20,loc=a3.6gumbel,scale=b3.6gumbel),qgumbel(T20,loc=a1.12gumbel,scale=b1.12gumbel),qgumbel(T20,loc=a3.24gumbel,scale=b3.24gumbel))->h20
d<-c(1,3,6,12,24)
lsfit(log(d),log(h20))->ft20
ft20$coefficients
exp(ft20$coefficients[[1]])
exp(ft20$coefficients[[1]])*hp^ft20$coefficients[[2]]->l20


#Tr di 50 anni
p(50) ->T50
T50

c(qgumbel(T50,loc=a3.1gumbel,scale=b3.1gumbel),qgumbel(T50,loc=a2.3gumbel,scale=b2.3gumbel),qgumbel(T50,loc=a3.6gumbel,scale=b3.6gumbel),qgumbel(T50,loc=a1.12gumbel,scale=b1.12gumbel),qgumbel(T50,loc=a3.24gumbel,scale=b3.24gumbel))->h50
d<-c(1,3,6,12,24)
lsfit(log(d),log(h50))->ft50
ft50$coefficients
exp(ft50$coefficients[[1]])
exp(ft50$coefficients[[1]])*hp^ft50$coefficients[[2]]->l50


#Tr di 25 anni
p(25) ->T100
T100

c(qgumbel(T100,loc=a3.1gumbel,scale=b3.1gumbel),qgumbel(T100,loc=a2.3gumbel,scale=b2.3gumbel),qgumbel(T100,loc=a3.6gumbel,scale=b3.6gumbel),qgumbel(T100,loc=a1.12gumbel,scale=b1.12gumbel),qgumbel(T100,loc=a3.24gumbel,scale=b3.24gumbel))->h100
d<-c(1,3,6,12,24)
lsfit(log(d),log(h100))->ft100
ft100$coefficients
exp(ft100$coefficients[[1]])
exp(ft100$coefficients[[1]])*hp^ft100$coefficients[[2]]->l100


plot(hp,l50,type="l",col="orange",ylab="h[mm]",xlab="t[ore]",main="Linee Segnalatrici di Possibilit Pluviometrica")
lines(hp,l100,type="l",col="blue")
lines(hp,l20,type="l",col="green")
lines(hp,l10,type="l",col="dark green")
lines(hp,l5,type="l",col="yellow")
text(20,99,"25 a",cex=0.8,col="blue")
text(20,110,"50 a",cex=0.8,col="orange")
text(20,68,"5 a",cex=0.8,col="yellow")
text(20,89,"20 a",cex=0.8,col="green")
text(20,79,"10 a",cex=0.8,col="dark green")

#bilogartmiche

hplog<-seq(from=0.1,to=25,by=0.1)

#Tr di 5 anni
p(5) ->T5
T5

c(qgumbel(T5,loc=a3.1gumbel,scale=b3.1gumbel),qgumbel(T5,loc=a2.3gumbel,scale=b2.3gumbel),qgumbel(T5,loc=a3.6gumbel,scale=b3.6gumbel),qgumbel(T5,loc=a1.12gumbel,scale=b1.12gumbel),qgumbel(T5,loc=a3.24gumbel,scale=b3.24gumbel))->h5
d<-c(1,3,6,12,24)
lsfit(log(d),log(h5))->ft5
ft5$coefficients
exp(ft5$coefficients[[1]])
exp(ft5$coefficients[[1]])*hplog^ft5$coefficients[[2]]->l5.log
plot(hplog,l5.log,type="l",col="orange") #vedere se lasciare x o mettere d

#Tr di 10 anni
p(10) ->T10
T10

c(qgumbel(T10,loc=a3.1gumbel,scale=b3.1gumbel),qgumbel(T10,loc=a2.3gumbel,scale=b2.3gumbel),qgumbel(T10,loc=a3.6gumbel,scale=b3.6gumbel),qgumbel(T10,loc=a1.12gumbel,scale=b1.12gumbel),qgumbel(T10,loc=a3.24gumbel,scale=b3.24gumbel))->h10
d<-c(1,3,6,12,24)
lsfit(log(d),log(h10))->ft10
ft10$coefficients
exp(ft10$coefficients[[1]])
exp(ft10$coefficients[[1]])*hplog^ft10$coefficients[[2]]->l10.log
ft10
#Tr di 20 anni
p(20) ->T20
T20

c(qgumbel(T20,loc=a3.1gumbel,scale=b3.1gumbel),qgumbel(T20,loc=a2.3gumbel,scale=b2.3gumbel),qgumbel(T20,loc=a3.6gumbel,scale=b2.6gumbel),qgumbel(T20,loc=a1.12gumbel,scale=b1.12gumbel),qgumbel(T20,loc=a3.24gumbel,scale=b3.24gumbel))->h20
d<-c(1,3,6,12,24)
lsfit(log(d),log(h20))->ft20
ft20$coefficients
exp(ft20$coefficients[[1]])
exp(ft20$coefficients[[1]])*hplog^ft20$coefficients[[2]]->l20.log


#Tr di 50 anni
p(50) ->T50
T50

c(qgumbel(T50,loc=a3.1gumbel,scale=b3.1gumbel),qgumbel(T50,loc=a2.3gumbel,scale=b2.3gumbel),qgumbel(T50,loc=a3.6gumbel,scale=b3.6gumbel),qgumbel(T50,loc=a1.12gumbel,scale=b1.12gumbel),qgumbel(T50,loc=a3.24gumbel,scale=b3.24gumbel))->h50
d<-c(1,3,6,12,24)
lsfit(log(d),log(h50))->ft50
ft50$coefficients
exp(ft50$coefficients[[1]])
exp(ft50$coefficients[[1]])*hplog^ft50$coefficients[[2]]->l50.log


#Tr di 25 anni
p(25) ->T100
T100

c(qgumbel(T100,loc=a3.1gumbel,scale=b3.1gumbel),qgumbel(T100,loc=a2.3gumbel,scale=b2.3gumbel),qgumbel(T100,loc=a3.6gumbel,scale=b3.6gumbel),qgumbel(T100,loc=a1.12gumbel,scale=b1.12gumbel),qgumbel(T100,loc=a3.24gumbel,scale=b3.24gumbel))->h100
d<-c(1,3,6,12,24)
lsfit(log(d),log(h100))->ft100
ft100$coefficients
exp(ft100$coefficients[[1]])
exp(ft100$coefficients[[1]])*hplog^ft100$coefficients[[2]]->l100.log
l100.log



plot(hplog,l50.log,type="l",col="orange",ylab="h[mm]",xlab="t[ore]",main="Linee Segnalatrici di Possibilit Pluviometrica",log="xy")
lines(hplog,l100.log,type="l",col="blue")
lines(hplog,l20.log,type="l",col="green")
lines(hplog,l10.log,type="l",col="dark green")
lines(hplog,l5.log,type="l",col="yellow")
text(10,91,"25 a",cex=0.8,col="blue")
text(10,99,"50 a",cex=0.8,col="orange")
text(10,50,"5 a",cex=0.8,col="yellow")
text(10,72,"20 a",cex=0.8,col="green")
text(10,67,"10 a",cex=0.8,col="dark green")

#Punti

quant<-c(T5,T10,T20,T100,T50)
hx.1<-c(qgumbel(quant,a3.1gumbel,b3.1gumbel))
hx.3<-c(qgumbel(quant,a2.3gumbel,b2.3gumbel))
hx.6<-c(qgumbel(quant,a3.6gumbel,b3.6gumbel))
hx.12<-c(qgumbel(quant,a1.12gumbel,b1.12gumbel))
hx.24<-c(qgumbel(quant,a2.24gumbel,b2.24gumbel))

P5<-c(hx.1[1],hx.3[1],hx.6[1],hx.12[1],hx.24[1])
P10<-c(hx.1[2],hx.3[2],hx.6[2],hx.12[2],hx.24[2])
P20<-c(hx.1[3],hx.3[3],hx.6[3],hx.12[3],hx.24[3])
P100<-c(hx.1[4],hx.3[4],hx.6[4],hx.12[4],hx.24[4])
P50<-c(hx.1[5],hx.3[5],hx.6[5],hx.12[5],hx.24[5])

#Plot finale

plot(hplog,l50.log,type="l",col="orange",ylab="h[mm]",xlab="t[ore]",main="Linee Segnalatrici di Possibilit Pluviometrica",log="xy")
lines(hplog,l100.log,type="l",col="blue")
lines(hplog,l20.log,type="l",col="green")
lines(hplog,l10.log,type="l",col="dark green")
lines(hplog,l5.log,type="l",col="yellow")
points(d,P5, pch=0)
points(d,P10, pch=1)
points(d,P20, pch=2)
points(d,P50, pch=3)
points(d,P100, pch=4)

text(10,91,"25 a",cex=0.8,col="blue")
text(10,99,"50 a",cex=0.8,col="orange")
text(10,50,"5 a",cex=0.8,col="yellow")
text(10,72,"20 a",cex=0.8,col="green")
text(10,67,"10 a",cex=0.8,col="dark green")


